-- Your SQL goes here
INSERT INTO permissions (permission, description) VALUES('modules.resource_management.vehicles.list.view', 'Permission to see list of vehicles');
INSERT INTO permissions (permission, description) VALUES('modules.resource_management.vehicles.core.edit', 'Permission to edit vehicles core data');
INSERT INTO roles_permissions (role_id, permission_id) VALUES('admin', 'modules.resource_management.vehicles.list.view');
INSERT INTO roles_permissions (role_id, permission_id) VALUES('admin', 'modules.resource_management.vehicles.core.edit');

CREATE TABLE vehicle_categories(
                                   id uuid DEFAULT uuid_generate_v1() PRIMARY KEY ,
                                   name Text NOT NULL,
                                   description Text
);
alter table vehicles
    add vehicle_category uuid;

alter table vehicles
    add constraint vehicles_vehicle_categories_id_fk
        foreign key (vehicle_category) references vehicle_categories (id)
            on update cascade on delete set null;
alter table vehicles
    drop column IF EXISTS next_inspection;

create table appointment_types
(
    type_id uuid default uuid_generate_v1() not null
        constraint appointment_types_pk
            primary key,
    name text not null,
    description text,
    interval integer
);

create table appointments
(
    id uuid default uuid_generate_v1() not null
        constraint appointments_pk
            primary key,
    type_id uuid not null
        constraint appointments_appointment_types_type_id_fk
            references appointment_types
            on update cascade on delete cascade,
    entity_id uuid not null
        constraint appointments_entities_entity_id_fk
            references entities
            on update cascade on delete cascade,
    appointment_date date not null
);

