-- Your SQL goes here
INSERT INTO permissions (permission, description)
VALUES ('modules.settings.view', 'Permission to see settings tab');

INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.settings.view', DEFAULT);

INSERT INTO permissions (permission, description)
VALUES ('modules.settings.role_permissions.view', 'Permission to see role permissions');

INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.settings.role_permissions.view', DEFAULT);

INSERT INTO permissions (permission, description)
VALUES ('modules.settings.role_permissions.edit', 'Permission to edit role permissions');

INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.settings.role_permissions.edit', DEFAULT);

alter table permissions
    add context bool default false not null;

alter table permissions
    add context_type text;

UPDATE public.permissions
SET context      = true,
    context_type = 'groups'
WHERE permission LIKE 'modules.member#_management.groups.members.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'groups'
WHERE permission LIKE 'modules.member#_management.groups.members.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'groups'
WHERE permission LIKE 'modules.member#_management.groups.permissions.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.units.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.drive#_permissions#_licenses.edit' ESCAPE '#';

UPDATE public.permissions
SET description  = 'Permission to access member list',
    context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.list.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'groups'
WHERE permission LIKE 'modules.member#_management.groups.permissions.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.iban#_bic.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.groups.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.communicator.email.send' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'groups'
WHERE permission LIKE 'modules.member#_management.groups.core.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.iban#_bic.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.core.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.communication.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.login.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'entity'
WHERE permission LIKE 'modules.scheduler.appointments.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.delete' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'groups'
WHERE permission LIKE 'modules.member#_management.groups.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'vehicles'
WHERE permission LIKE 'modules.resource#_management.vehicles.core.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.drive#_permissions#_licenses.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.image.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.communication.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.units.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.image.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.qualifications.edit' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'groups'
WHERE permission LIKE 'modules.member#_management.groups.delete' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'entity'
WHERE permission LIKE 'modules.scheduler.appointments.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'vehicles'
WHERE permission LIKE 'modules.resource#_management.vehicles.core.delete' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.login.view' ESCAPE '#';

UPDATE public.permissions
SET context      = true,
    context_type = 'members'
WHERE permission LIKE 'modules.member#_management.profile.qualification.view' ESCAPE '#';

