$( document ).ready(function() {
    var member_search = new MiniSearchbar("add_event_search", EventCreateModule.member_responsible_callback);
    member_search.setup();
    var organiser_search = new MiniSearchbar("add_event_organiser_search", EventCreateModule.organiser_callback);
    organiser_search.setup();

    $("#member_responsible_remove").on("click", EventCreateModule.member_responsible_remove);
    $("#organiser_remove").on("click", EventCreateModule.organiser_remove);
    load_event_types_legacy(EventCreateModule.set_event_types);
    load_groups(EventCreateModule.set_groups);
    $("#create_event_btn").on("click", EventCreateModule.add_event);
});

EventCreateModule = ( function() {
    let member_responsible_callback = function(caller){
        $("#create-event-member-search").hide();
        $("#member_responsible").val($(caller).data("firstname")+" "+$(caller).data("lastname")).attr("data-entity-id", $(caller).data("entity-id"));
        $("#member_responsible_input_group").show();
    };
    let member_responsible_remove = function(){
        $("#member_responsible_input_group").hide();
        $("#member_responsible").val("").removeData("entity-id").removeAttr("data-entity-id");
        $("#add_event_search-searchbar").val("");
        $(".add_event_search-search-result-overlay-list").html("");
        $("#create-event-member-search").show();
    };
    let organiser_callback = function(caller){
        $("#create-event-organiser-search").hide();
        $("#organiser").val($(caller).data("company")+" "+$(caller).data("firstname")+" "+$(caller).data("lastname")).attr("data-entity-id", $(caller).data("entity-id"));
        $("#organiser_input_group").show();
    };
    let organiser_remove = function(){
        $("#organiser_input_group").hide();
        $("#organiser").val("").removeData("entity-id").removeAttr("data-entity-id");
        $("#add_event_organiser_search-searchbar").val("");
        $(".add_event_organiser_search-search-result-overlay-list").html("");
        $("#create-event-organiser-search").show();
    };
    let add_event = function(){
        if($("#create_event_form")[0].checkValidity()) {
            let group = {};
            group.name = $("#name").val();
            group.start = $("#start_date").val()+"T"+$("#start_time").val();
            group.end = $("#end_date").val()+"T"+$("#end_time").val();
            if($("#site").val().length > 0){
                group.site = $("#site").val();
            }
            if($("#etype").val().length > 0){
                group.etype = $("#etype option:selected").data("type-id");
            }
            group.related_group = $("#related_group option:selected").data("group-id");
            if($("#member_responsible").data("entity-id")){
                group.member_responsible = $("#member_responsible").data("entity-id");
            }
            if($("#organiser").data("entity-id")){
                group.organiser_id = $("#organiser").data("entity-id");
            }
            if($("#other").val().length > 0){
                group.other = $("#other").val();
            }
            if($("#other_intern").val().length > 0){
                group.other_intern = $("#other_intern").val();
            }
            if($("#contact_on_site_name").val().length > 0){
                group.contact_on_site_name = $("#contact_on_site_name").val();
            }
            if($("#contact_on_site_phone").val().length > 0){
                group.contact_on_site_phone = $("#contact_on_site_phone").val();
            }
            $.ajax({
                url: '/api/events',
                type: 'POST',
                contentType: 'application/json',
                data: JSON.stringify(group),
                success: function (data) {
                    if (is_ok(data)) {
                        window.location.href="/portal/em/event?id="+data.entity_id;
                    }

                },
                timeout: 3000,
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
        }else{
            $('<input type="submit">').hide().appendTo("#create_event_form").click().remove();
        }
    };
    let set_event_types = function(res){
        $(res).each(function(){
            let is_billable = "";
            if(this.is_billable){
                is_billable = " (€) ";
            }
            $("#etype").append("<option data-type-id=\""+this.type_id+"\">"+this.name+is_billable+"</option>");
        });
    };
    let set_groups = function(res){
        $(res.groups).each(function(){
            $("#related_group").append("<option data-group-id=\""+this.group_id+"\">"+this.name+"</option>");
        });
    }
    return{
        member_responsible_callback: member_responsible_callback,
        member_responsible_remove: member_responsible_remove,
        organiser_callback: organiser_callback,
        organiser_remove: organiser_remove,
        add_event: add_event,
        set_groups: set_groups,
        set_event_types: set_event_types,
    }
}());