$( document ).ready(function() {
    var organiser_search = new MiniSearchbar("add_event_organiser_search", RequestCreateModule.organiser_callback);
    organiser_search.setup();

    $("#organiser_remove").on("click", RequestCreateModule.organiser_remove);
    load_event_types_legacy(RequestCreateModule.set_event_types);
    $("#create_request_btn").on("click", RequestCreateModule.add_request);
});

RequestCreateModule = ( function() {
    let organiser_callback = function(caller){
        $("#create-event-organiser-search").hide();
        $("#organiser").val($(caller).data("company")+" "+$(caller).data("firstname")+" "+$(caller).data("lastname")).attr("data-entity-id", $(caller).data("entity-id"));
        $("#organiser_input_group").show();
    };
    let organiser_remove = function(){
        $("#organiser_input_group").hide();
        $("#organiser").val("").removeData("entity-id").removeAttr("data-entity-id");
        $("#add_event_organiser_search-searchbar").val("");
        $(".add_event_organiser_search-search-result-overlay-list").html("");
        $("#create-event-organiser-search").show();
    };
    let add_request = function(){
        if($("#create_request_form")[0].checkValidity()) {
            let request = {};
            request.name = $("#name").val();
            if($("#timescale").val().length > 0) {
                request.timescale = $("#timescale").val();
            }
            if($("#site").val().length > 0){
                request.site = $("#site").val();
            }
            if($("#etype").val().length > 0){
                request.etype = $("#etype option:selected").data("type-id");
            }
            if($("#organiser").data("entity-id")){
                request.organiser_id = $("#organiser").data("entity-id");
            }
            if($("#specials").val().length > 0){
                request.specials = $("#specials").val();
            }
            if($("#requested").val().length > 0){
                request.requested = $("#requested").val();
            }
            if($("#contact_on_site_name").val().length > 0){
                request.contact_on_site_name = $("#contact_on_site_name").val();
            }
            if($("#contact_on_site_phone").val().length > 0){
                request.contact_on_site_phone = $("#contact_on_site_phone").val();
            }
            if($("#expected_attendees").val().length > 0){
                request.expected_attendees = $("#expected_attendees").val();
            }
            if($("#risk_potential").val().length > 0){
                request.risk_potential = $("#risk_potential").val();
            }
            console.log(request);
            $.ajax({
                url: '/api/event_requests',
                type: 'POST',
                contentType: 'application/json',
                data: JSON.stringify(request),
                success: function (data) {
                    if (is_ok(data)) {
                        window.location.href = '/portal/em/requests';
                    }

                },
                timeout: 3000,
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
        }else{
            $('<input type="submit">').hide().appendTo("#create_request_form").click().remove();
        }
    };
    let set_event_types = function(res){
        $(res).each(function(){
            let is_billable = "";
            if(this.is_billable){
                is_billable = " (€) ";
            }
            $("#etype").append("<option data-type-id=\""+this.type_id+"\">"+this.name+is_billable+"</option>");
        });
    };
    let set_groups = function(res){
        $(res.groups).each(function(){
            $("#related_group").append("<option data-group-id=\""+this.group_id+"\">"+this.name+"</option>");
        });
    }
    return{
        set_groups: set_groups,
        set_event_types: set_event_types,
        add_request: add_request,
        organiser_remove: organiser_remove,
        organiser_callback: organiser_callback,
    }
}());