let searchbar = $("#group-detailed-view-member-searchbar");
var overlay = $(".group-detailed-view-member-search-result-overlay");
var overlay_list = $(".group-detailed-view-member-search-result-overlay-list");

$( document ).ready(function() {
    $('body').click(function(evt){
        if(evt.target.class === "group-detailed-view-member-search-result-overlay")
            return;
        if($(evt.target).closest('.group-detailed-view-member-search-result-overlay').length)
            return;
        $(".group-detailed-view-member-search-result-overlay").hide();
    });

    //Remove current searchbar value on click
    searchbar.on("click", GroupMemberSearch.searchbar_onclick);
    searchbar.on("keyup paste cut", GroupMemberSearch.searchbar_typing);
    searchbar.on("mouseenter focusin", function (){
        overlay.show();
    });
    overlay.on("focusout mouseleave", function (){
        overlay.hide();
    })
});

GroupMemberSearch = ( function() {
    var searchbar_onclick = function(){
      searchbar.val("");
      overlay.show()
    };
    var searchbar_typing = function (){
        $("#group-detailed-view-member-searchbar-type").html("");
        overlay_list.html("");
        overlay.show();

            $.ajax({
                url: '/api/members/',
                type: 'GET',
                data: {
                    "name": searchbar.val()
                },
                contentType: 'application/json',
                success: function(data) {
                    if(is_ok(data)) {
                        $.each(data.members, function(index, value){
                            overlay_list.append("<span tabindex=\"0\" class=\"group-detailed-view-member-search-result-overlay-result\" style=\"cursor: pointer\" data-group-id=\""+value.group_id+"\" data-entity-id=\""+value.entity_id+"\" data-firstname=\""+value.firstname+"\" data-lastname=\""+value.lastname+"\"><li class='list-group-item'><span class=\"badge badge-secondary\">Hinzufügen:</span> "+value.firstname+" "+value.lastname+"</li></span>")

                        });
                        $(".group-detailed-view-member-search-result-overlay-result").off("click").on("click", function(){
                            GroupModule.add_member_click_listener(this)
                        });
                    }

                },
                timeout: 3000,
                error: function() {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
    };
    return {
        searchbar_onclick : searchbar_onclick,
        searchbar_typing : searchbar_typing,
    };
})();