let all_checked = false;
let entries_per_page = 10;
let page = 1;
let total_page_count = 1;

$( document ).ready(function() {
    VehicleModule.get_vehicle_categories();
    VehicleModule.get_vehicles();
    $(".vehicle_detailed_view_submit").on("click", VehicleModule.save_vehicle);
    VehicleModule.check_create_vehicle_permission();
    $(".vehicle_new_submit").on("click", VehicleModule.create_vehicle);
    $(".check_all_vehicles").on("click", function(){
        if(all_checked){
            $(".vehicle_checkbox").attr("checked", false);
            all_checked = false;
        }else{
            $(".vehicle_checkbox").attr("checked", true);
            all_checked = true;
        }

    });
    $(".vehicle_delete_button").on("click", VehicleModule.delete_vehicles);
    $(".vehicle_list_nav_next").on("click", VehicleModule.pagination_forward);
    $(".vehicle_list_nav_back").on("click", VehicleModule.pagination_backward);
    $(".vehicle_list_nav_numbers").on("click", VehicleModule.pagination_numbers);
});

VehicleModule = ( function() {
    let vehicle_list = [];
    let pagination_forward = function(){
        if(page < total_page_count){
            page++;
            VehicleModule.get_vehicles();
        }
    };
    let pagination_backward = function(){
        if(page > 1){
            page--;
            VehicleModule.get_vehicles();
        }
    };
    let pagination_numbers = function(){
        page = parseInt($(this).text());
        VehicleModule.get_vehicles();
    };
    let pagination_update = function(){
        $(".vehicle_list_nav_numbers").remove();
        for(let i = total_page_count; i>0;i--){
            if(page === i){
                $(".vehicle_list_nav_back_li").after("<li class=\"page-item vehicle_list_nav_numbers disabled\"><a class=\"page-link\" href=\"#\">"+i+"</a></li>");
            }else{
                $(".vehicle_list_nav_back_li").after("<li class=\"page-item vehicle_list_nav_numbers\"><a class=\"page-link\" href=\"#\">"+i+"</a></li>");
            }
        }
        $(".vehicle_list_nav_numbers").on("click", VehicleModule.pagination_numbers);

        if(page === total_page_count){
            $(".vehicle_list_nav_next").parent().addClass("disabled");
        }else{
            $(".vehicle_list_nav_next").parent().removeClass("disabled");
        }
        if(page === 1){
            $(".vehicle_list_nav_back").parent().addClass("disabled");
        }else{
            $(".vehicle_list_nav_back").parent().removeClass("disabled");
        }
    }
    let get_vehicle_categories = function(){
        $.ajax({
            type: "GET",
            url: "/api/resources/vehicles/categories",
            contentType: 'application/json',
            timeout: 3000,
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    $(data).each(function(){
                        $(".vehicle_categories_select").append("<option data-category-id=\""+this.id+"\">"+this.name+"</option>");
                    });
                }
            }
        });
    };
    let get_vehicles = function(){
        $("#vehicle_list_tbody").html("");
        $.ajax({
            type: "GET",
            url: "/api/resources/vehicles?entries="+entries_per_page+"&page="+page,
            contentType: 'application/json',
            timeout: 3000,
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    vehicle_list = data.vehicle_list;
                    total_vehicle_count = data.total_vehicle_count;
                    total_page_count = Math.ceil(total_vehicle_count/entries_per_page);
                    VehicleModule.pagination_update();

                    $(vehicle_list).each(function(){
                        let is_operational = "";
                        if(this.is_operational === true){
                            is_operational = "✓";
                        }else{
                            is_operational = "×"
                        }

                        $("#vehicle_list_tbody").append("<tr class=\"vehicle_list_select_tr\" data-vehicle-id=\""+this.entity_id+"\">\n" +
                            "                                <td><input type=\"checkbox\" class=\"vehicle_checkbox\" data-vehicle-id=\""+this.entity_id+"\"></td>\n" +
                            "                                <td>"+this.identifier+"</td>\n" +
                            "                                <td>"+this.numberplate+"</td>\n" +
                            "                                <td>"+is_operational+"</td>\n"+
                            "                            </tr>");
                    });
                    $(".vehicle_list_select_tr").unbind("click").on("click", VehicleModule.load_vehicle_details);
                }
            }
        });
    };
    let load_vehicle_details = function(){
        let tr = this;
        $("#vehicle_detailed_view > input").val("");
        $(".scheduler-tbody").html("");
        $("#vehicle_detailed_view").show();
        $(vehicle_list).each(function(){
            if(this.entity_id === $(tr).data("vehicle-id")){
                $("#vehicle_detailed_view_identifier_input").val(this.identifier);
                $("#vehicle_detailed_view_numberplate_input").val(this.numberplate);
                $("#vehicle_detailed_view_description_input").val(this.description);
                if(this.is_operational){
                    $("#vehicle_detailed_view_is_operational_input").attr("checked", true);
                }
                $("#vehicle_detailed_view_admissable_total_weight_input").val(this.admissible_total_weight);

                let c1 = this.vehicle_category;
                $("#vehicle_detailed_view_category_input > option").each(function(key, val){
                    let c2 = $(val).data("category-id");
                    if(c2 === c1){
                        $(val).attr("selected", true);
                    }
                });

                $("#vehicle_detailed_view_entity_id").val(this.entity_id);
                let entity_id = this.entity_id;
                $.ajax({
                    type: "GET",
                    url: "/api/info/caller/permissions?permission=modules.scheduler.appointments.view&entity_id="+entity_id,
                    contentType: 'application/json',
                    timeout: 3000,
                    error: function () {
                        alert("Verbindung zum Server unterbrochen!");
                    },
                    success: function (data) {
                        if(is_ok(data)) {
                            if(data){
                                $(".scheduler").show();
                                $(".scheduler_add_appointment_entity_id").val(entity_id);
                                Scheduler.list_appointments();
                            }else{
                                $(".scheduler").hide();
                            }
                        }
                    }
                });
            }
        });
    };
    let save_vehicle = function(){
        let vehicle = new Object();
        vehicle.identifier = $("#vehicle_detailed_view_identifier_input").val();
        if($("#vehicle_detailed_view_numberplate_input").val().length > 0){
            vehicle.numberplate = $("#vehicle_detailed_view_numberplate_input").val();
        }
        if($("#vehicle_detailed_view_description_input").val().length > 0){
            vehicle.description = $("#vehicle_detailed_view_description_input").val();
        }
        if($("#vehicle_detailed_view_is_operational_input").prop('checked')){
            vehicle.is_operational = true;
        }else{
            vehicle.is_operational = false;
        }
        if($("#vehicle_detailed_view_admissable_total_weight_input").val().length > 0){
            vehicle.admissible_total_weight = parseInt($("#vehicle_detailed_view_admissable_total_weight_input").val());
        }
        if($("#vehicle_detailed_view_category_input option:selected").data("category-id") !== null){
            vehicle.vehicle_category = $("#vehicle_detailed_view_category_input option:selected").data("category-id");
        }
        vehicle.entity_id = $("#vehicle_detailed_view_entity_id").val();

        if(vehicle.identifier.trim() != '') {
            $.ajax({
                type: "PUT",
                url: "/api/resources/vehicles/" + vehicle.entity_id,
                contentType: 'application/json',
                timeout: 3000,
                data: JSON.stringify(vehicle),
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                },
                success: function (data) {
                    if (is_ok(data)) {
                        window.location.reload(true);
                    }
                }
            });
        }else{
            alert("Bitte eine Bezeichnung für dieses Fahrzeug eingeben!");
        }
    };
    let check_create_vehicle_permission = function(){
        $.ajax({
            type: "GET",
            url: "/api/info/caller/permissions?permission=modules.resource_management.vehicles.core.create",
            contentType: 'application/json',
            timeout: 3000,
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    if(data) {
                        $(".vehicle_create_new_card").show();
                    }
                }
            }
        });
    };
    let create_vehicle = function(){
        let vehicle = {};
        vehicle.identifier = $("#vehicle_new_identifier_input").val();
        if($("#vehicle_new_numberplate_input").val().length > 0){
            vehicle.numberplate = $("#vehicle_new_numberplate_input").val();
        }
        if($("#vehicle_new_description_input").val().length > 0){
            vehicle.description = $("#vehicle_new_description_input").val();
        }
        vehicle.is_operational = !!$("#vehicle_new_is_operational_input").prop('checked');
        if($("#vehicle_new_admissable_total_weight_input").val().length > 0){
            vehicle.admissible_total_weight = parseInt($("#vehicle_new_admissable_total_weight_input").val());
        }
        if($("#vehicle_new_category_input option:selected").data("category-id") !== null){
            vehicle.vehicle_category = $("#vehicle_new_category_input option:selected").data("category-id");
        }

        if(vehicle.identifier.trim() != ''){
            $.ajax({
                type: "POST",
                url: "/api/resources/vehicles/",
                contentType: 'application/json',
                timeout: 3000,
                data: JSON.stringify(vehicle),
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                },
                success: function (data) {
                    if(is_ok(data)) {
                        window.location.reload(true);
                    }
                }
            });
        }else{
            alert("Bitte eine Bezeichnung für dieses Fahrzeug eingeben!");
        }
    };
    let delete_vehicles = function(){
        let vehicle_list = [];
        $(".vehicle_checkbox").each(function(k, v){
            if($(v).prop("checked")){
                vehicle_list.push($(v).data("vehicle-id"));
            }
        });
        $.ajax({
            type: "DELETE",
            url: "/api/resources/vehicles/",
            contentType: 'application/json',
            timeout: 3000,
            data: JSON.stringify(vehicle_list),
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    $(".vehicle_checkbox").each(function(k,v){
                        if(vehicle_list.includes($(v).data("vehicle-id"))){
                            $(this).parent().parent().remove();
                        }
                    })
                }
            }
        });
    };
    return{
        get_vehicle_categories: get_vehicle_categories,
        get_vehicles: get_vehicles,
        load_vehicle_details: load_vehicle_details,
        save_vehicle: save_vehicle,
        check_create_vehicle_permission: check_create_vehicle_permission,
        create_vehicle: create_vehicle,
        delete_vehicles: delete_vehicles,
        pagination_backward: pagination_backward,
        pagination_forward: pagination_forward,
        pagination_update: pagination_update,
        pagination_numbers: pagination_numbers,
    };
})();