use lettre::{AsyncSmtpTransport, Message, Tokio1Executor};
use lettre::message::MessageBuilder;
use lettre::transport::smtp::authentication::Credentials;
use rocket::futures::SinkExt;
use rocket::State;

use crate::Settings;

pub fn setup(settings: &Settings) -> Result<AsyncSmtpTransport<Tokio1Executor>, lettre::transport::smtp::Error> {
    let creds = Credentials::new(settings.mail.smtp_username.clone(), settings.mail.smtp_password.clone());
    let relay = AsyncSmtpTransport::<Tokio1Executor>::starttls_relay(&settings.mail.smtp_host.clone())?;
    Ok(relay.credentials(creds).build())
}

