pub mod modules {
    pub mod dashboard {
        pub const VIEW: &'static str = "modules.dashboard.view";
    }
    pub mod member_management {
        pub const SEARCH: &'static str = "modules.member_management.search";
        pub const VIEW: &'static str = "modules.member_management.view";
        pub mod list {
            pub const VIEW: &'static str = "modules.member_management.list.view";
        }
        pub mod iban_bic{
            pub const VIEW: &'static str = "modules.member_management.iban_bic.view";
            pub const EDIT: &'static str = "modules.member_management.iban_bic.edit";
        }
        pub mod groups {
            pub const VIEW: &'static str = "modules.member_management.groups.view";
            pub const EDIT: &'static str = "modules.member_management.groups.edit";
            pub const CREATE: &'static str = "modules.member_management.groups.create";
            pub const DELETE: &'static str = "modules.member_management.groups.delete";

            pub mod members {
                pub const VIEW: &'static str = "modules.member_management.groups.members.view";
                pub const EDIT: &'static str = "modules.member_management.groups.members.edit";
            }

            pub mod permissions {
                pub const VIEW: &'static str = "modules.member_management.groups.permissions.view";
                pub const EDIT: &'static str = "modules.member_management.groups.permissions.edit";
            }

            pub mod core {
                pub const EDIT: &'static str = "modules.member_management.groups.core.edit";
            }
        }
        pub mod profile {
            pub const VIEW: &'static str = "modules.member_management.profile.view";
            pub const EDIT: &'static str = "modules.member_management.profile.edit";
            pub const CREATE: &'static str = "modules.member_management.profile.create";
            pub const DELETE: &'static str = "modules.member_management.profile.delete";
            pub mod qualifications {
                pub const VIEW: &'static str =
                    "modules.member_management.profile.qualification.view";
                pub const EDIT: &'static str =
                    "modules.member_management.profile.qualifications.edit";
            }
            pub mod image {
                pub const VIEW: &'static str = "modules.member_management.profile.image.view";
                pub const EDIT: &'static str = "modules.member_management.profile.image.edit";
            }
            pub mod drive_permissions_licenses {
                pub const VIEW: &'static str =
                    "modules.member_management.profile.drive_permissions_licenses.view";
                pub const EDIT: &'static str =
                    "modules.member_management.profile.drive_permissions_licenses.edit";
            }
            pub mod communication {
                pub const VIEW: &'static str =
                    "modules.member_management.profile.communication.view";
                pub const EDIT: &'static str =
                    "modules.member_management.profile.communication.edit";
            }
            pub mod list {
                pub const VIEW: &'static str = "modules.member_management.list.view";
            }
            pub mod groups {
                pub const VIEW: &'static str = "modules.member_management.profile.groups.view";
                pub const EDIT: &'static str = "modules.member_management.profile.groups.edit";
            }
            pub mod core {
                pub const EDIT: &'static str = "modules.member_management.profile.core.edit";
            }
        }
    }
    pub mod event_management {
        pub const VIEW: &'static str = "modules.event_management.view";

        pub mod organisers{
            pub const VIEW: &'static str = "modules.event_management.organisers.view";
            pub const EDIT: &'static str = "modules.event_management.organisers.edit";
            pub const CREATE: &'static str = "modules.event_management.organisers.create";
            pub const DELETE: &'static str = "modules.event_management.organisers.delete";
        }
        pub mod events{
            pub const VIEW: &'static str = "modules.event_management.events.view";
            pub const EDIT: &'static str = "modules.event_management.events.edit";
            pub const CREATE: &'static str = "modules.event_management.events.create";
            pub const DELETE: &'static str = "modules.event_management.events.delete";
        }
        pub mod requests{
            pub mod assignments{
                pub const ASSIGN: &'static str = "modules.event_management.requests.assignments.assign";
                pub const RESET: &'static str = "modules.event_management.requests.assignments.reset"; //TODO: add to database
            }
            pub const VIEW: &'static str = "modules.event_management.requests.view";
            pub const EDIT: &'static str = "modules.event_management.requests.edit";
            pub const CREATE: &'static str = "modules.event_management.requests.create";
            pub const DELETE: &'static str = "modules.event_management.requests.delete";
        }
    }
    pub mod resource_management{
        pub const VIEW: &'static str = "modules.resource_management.view";
        pub mod vehicles{
            pub mod core{
                pub const VIEW: &'static str = "modules.resource_management.vehicles.core.view";
                pub const EDIT: &'static str = "modules.resource_management.vehicles.core.edit";
                pub const CREATE: &'static str = "modules.resource_management.vehicles.core.create";
                pub const DELETE: &'static str = "modules.resource_management.vehicles.core.delete";
            }
            pub mod list{
                pub const VIEW: &'static str = "modules.resource_management.vehicles.list.view";
            }
        }
    }
    pub mod configuration {
        pub mod fields {
            pub mod communication_types {
                pub const VIEW: &'static str =
                    "modules.configuration.fields.communication_types.view";
            }
        }
    }
    pub mod units{
        pub const EDIT: &'static str = "modules.units.edit";
        pub const CREATE: &'static str = "modules.units.create";
        pub const DELETE: &'static str = "modules.units.delete";
        pub mod members {
            pub const VIEW: &'static str = "modules.units.members.view";
            pub const EDIT: &'static str = "modules.units.members.edit";
        }
    }
    pub mod communicator{
        pub const VIEW: &'static str = "modules.communicator.view";
        pub const EDIT: &'static str = "modules.communicator.edit";
        pub mod email{
            pub const SEND: &'static str = "modules.communicator.email.send";
        }
    }
    pub mod scheduler{
        pub const VIEW: &'static str = "modules.scheduler.view";
        pub mod appointments{
            pub const VIEW: &'static str = "modules.scheduler.appointments.view";
            pub const EDIT: &'static str = "modules.scheduler.appointments.edit";
        }
    }

    pub mod settings {
        pub const VIEW: &'static str = "modules.settings.view";

        pub mod role_permissions {
            pub const VIEW: &'static str = "modules.settings.role_permissions.view";
            pub const EDIT: &'static str = "modules.settings.role_permissions.edit";
        }
    }

    pub mod event_billing {
        pub const VIEW: &'static str = "modules.event_billing.view";
        pub const APPROVE: &'static str = "modules.event_billing.approve";

        pub mod personnel {
            pub const VIEW: &'static str = "modules.event_billing.personnel.view";
            pub const EDIT: &'static str = "modules.event_billing.personnel.edit";
        }

        pub mod start_end_times {
            pub const VIEW: &'static str = "modules.event_billing.start_end_times.view";
            pub const EDIT: &'static str = "modules.event_billing.start_end_times.edit";
        }
    }
}
